Minute = 60  # we measure in seconds
Hour = 60*Minute
Day = 24*Hour
Week = 7*Day
# Month and Year are not fixed units.

AtHour = 2
AtMin = 1

class Time
  def prevDay()
    result = self - Day
    result -= Hour  if result.wday() == wday()  # DST
    result += Hour  if (wday() + 7 - result.wday()) % 7 == 2  # DST
    result
  end
  def nextDay()
    result = self + Day
    result += Hour  if result.wday() == wday()  # DST
    result -= Hour  if (result.wday() + 7 - wday()) % 7 == 2  # DST
    result
  end

  def prevWeek()
    result = self - Week
    result += Hour  if (result.wday() + 7 - wday()) % 7 == 1  # DST
    result -= Hour  if (wday() + 7 - result.wday()) % 7 == 1  # DST
    result
  end

  def nextWeek()
    result = self + Week
    result += Hour  if (wday() + 7 - result.wday()) % 7 == 1  # DST
    result -= Hour  if (result.wday() + 7 - wday()) % 7 == 1  # DST
    result
  end

  def prevYear()
    Time.local(year-1, month, day, hour, min, 0)
  end

  def nextYear()
    Time.local(year+1, month, day, hour, min, 0)
  end

  # Returns date when date is precisely one week after self
  def nextDayAfter(date)
    result = Time.local(date.year, date.month, date.day,
			self.hour, self.min, 0)
    result = result.nextDay()  if result < date
    result
  end

  def nextWeekAfter(date)
    result = Time.local(date.year, date.month, date.day,
			self.hour, self.min, 0)
    result = result.nextDay()  while result < date or result.wday != self.wday
    result
  end

  def nextYearAfter(date)
    result = Time.local(date.year, self.month, self.day,
			self.hour, self.min, 0)
    if (result < date)
      result = Time.local(date.year+1, self.month, self.day,
			  self.hour, self.min, 0)
    end
    result
  end
end
