require 'agenda/tkview'

module Agenda
  class TkDay < TkView
    alias TkView_init initialize
    def initialize(parent, *args)
      TkView_init(parent, *args)
      @day = TkTime.new(parent.top_bar, 'show'=>'days')
      @day.time = Time.now()
      @day.add_observer(self)
    end

    def update(field)
      show(@day.time)
    end

    def remove_from()
      @day.pack_forget
      @frame.pack_forget
    end

    def display_on(holder)
      @day.pack('side'=>'left', 'fill'=>'x')
      @frame.pack('fill'=>'both', 'expand'=>true)
    end

    def print_appt(interval, appt)
      result = (appt.time < interval.time) ? appt.time.strftime("%b %d ") : ""
      time_str = print_time(interval, appt)
      result += time_str + "  "  if time_str != ""
      return result
    end

    def earlier()
      show(@time.prevDay)
    end

    def show(day=Time.now)
      @time = Time.local(0, 0, 0, day.day, day.month, day.year, *[nil]*4)
      setTimeFrame(TimeInterval.new(@time, Day))
      @day.time = @time
    end

    def later()
      show(@time.nextDay)
    end
  end
end
