require 'agenda/tkview'

module Agenda
  class TkWeek < TkView
    alias TkView_init initialize
    def initialize(parent, *args)
      TkView_init(parent, *args)
      @week = TkTime.new(parent.top_bar, 'show'=>'days')
      @week.time = Time.now()
      @week.add_observer(self)
    end
    attr_reader :time

    def update(field)
      show(@week.time)
    end

    def remove_from()
      @week.pack_forget
      @frame.pack_forget
    end

    def display_on(holder)
      @week.pack('side'=>'left', 'fill'=>'x')
      @frame.pack('fill'=>'both', 'expand'=>true)
    end

    def print_appt(interval, appt)
      result = appt.time.strftime( (appt.time<interval.time)?"%b %d ":"%a ")
      time_str = print_time(interval, appt)
      result += time_str  if time_str != ""
      return result + "  "
    end

    def earlier()
      show(@time.prevWeek)
    end

    def show(week=Time.now)
      @time = Time.local(0, 0, 0, week.day, week.month, week.year, *[nil]*4)
      setTimeFrame(TimeInterval.new(@time, Week))
      @week.time = @time
    end

    def later()
      show(@time.nextWeek)
    end
  end
end
